//window.focus();

const socket = io();
const canvas2d = $('#canvas-2d')[0];
const context = canvas2d.getContext('2d');
const canvas3d = $('#canvas-3d')[0];
//const playerImage = $("#player-image")[0];
const canvasVic = $('#canvas-vic')[0];
const contextVic = canvasVic.getContext('2d');
const canvasMob = $('#canvas-mob')[0];
const contextMob = canvasMob.getContext('2d');
const canvasLoad = $('#canvas-load')[0];
const contextLoad = canvasLoad.getContext('2d');

window.onload=function(){
    console.log('------window.onload-------');
}
$("#start-screen").hide();

window.onkeydown = function(e) {
    if (e.keyCode == 9)
      return false; // Disable Tab!
  }

var mDeviceType = 'PC'; //0:PC, 1:Mobile
function mGetDeviceType() {
    console.log('Device:'+navigator.userAgent);
    if (navigator.userAgent.match(/iPhone|iPad|Android/)) { ///iPhone|Android.+Mobile/
        mDeviceType = 'Mobile';
        //$("#canvas-mob").show();
      //return true;
    } else {
      //return false;
      //$("#canvas-mob").hide();
    }
    //mDeviceType = navigator.userAgent;
}

mGetDeviceType();
console.log('mDeviceType:'+mDeviceType);


const FIELD_SC = 4;
const FIELD_WIDTH = 1000*FIELD_SC, FIELD_HEIGHT = 1000*FIELD_SC;
var mFieldGridSize = 240;
var mFieldGridSizeH = 180;

const renderer = new THREE.WebGLRenderer({canvas: canvas3d});
renderer.setClearColor('grey');//'skyblue'
renderer.shadowMap.enabled = true;

const scene = new THREE.Scene();
const camera = new THREE.PerspectiveCamera( 50, 2, 0.1, FIELD_WIDTH*2 );

const textureLoader = new THREE.TextureLoader();

// Floor
var mSc = 2;
const groundTexture = textureLoader.load('/static/image/p0305_m.jpeg');
const groundMaterial = new THREE.MeshLambertMaterial( { map: groundTexture } );
const floorGeometry = new THREE.PlaneGeometry(FIELD_WIDTH*2, FIELD_HEIGHT*2, 1, 1);
const floorMaterial = new THREE.MeshLambertMaterial({color : 'green'});//'lawngreen'
const floorMesh = new THREE.Mesh(floorGeometry, floorMaterial); //groundMaterial
floorMesh.position.set(FIELD_WIDTH/2, 0, FIELD_HEIGHT/2);
floorMesh.receiveShadow = true;
floorMesh.rotation.x = - Math.PI / 2; 
scene.add(floorMesh);

// Side 
const sideGeometry = new THREE.CylinderGeometry(FIELD_WIDTH,FIELD_WIDTH,FIELD_WIDTH*2,50,50,true); //(FIELD_WIDTH,FIELD_WIDTH,FIELD_WIDTH,50);
//const sideTexture = new THREE.Texture(playerImage);
const sideTexture = textureLoader.load('/static/image/ELFADSC08963_TP_V.jpg'); //skyimage1.png, skyimage1.png
//sideTexture.needsUpdate = true;
const sideMaterial = new THREE.MeshLambertMaterial({map: sideTexture, side: THREE.DoubleSide});//'lawngreen'
// const sideMaterial = new THREE.MeshBasicMaterial({
//     map: texture, // テクスチャーを指定
//     color: 0x007eff, // 色
//     transparent: true, // 透明の表示許可
//     blending: THREE.AdditiveBlending, // ブレンドモード
//     side: THREE.DoubleSide, // 表裏の表示設定
//     depthWrite: false // デプスバッファへの書き込み可否
//   });
const sideMesh = new THREE.Mesh(sideGeometry, sideMaterial);
sideMesh.position.set(FIELD_WIDTH/2, FIELD_WIDTH-100, FIELD_HEIGHT/2);
sideMesh.receiveShadow = true;
//sideMesh.rotation.x = - Math.PI / 2; 
scene.add(sideMesh);


// Grid
for(var i=0;i<FIELD_WIDTH/mFieldGridSize/2;i++){
    for(var j=0;j<FIELD_WIDTH/mFieldGridSize/2;j++){
    var floorGeometry1 = new THREE.PlaneGeometry(mFieldGridSize, mFieldGridSize, 1, 1);
    var floorMaterial1 = new THREE.MeshLambertMaterial({color : 'lawngreen'});//'lawngreen'
    var floorMesh1 = new THREE.Mesh(floorGeometry1, floorMaterial1);
    floorMesh1.position.set(mFieldGridSize*i*2+mFieldGridSize/2, 1, mFieldGridSize*j*2+mFieldGridSize/2);
    floorMesh1.receiveShadow = true;
    floorMesh1.rotation.x = - Math.PI / 2; 
    scene.add(floorMesh1);
    }
} 

// var ng_ = 5;
// for(var i=0;i<ng_;i++){
//     for(var j=0;j<ng_;j++){
//         var s_ = FIELD_WIDTH/ng_;
//         var floorGeometry1 = new THREE.PlaneGeometry(s_, s_, 1, 1);
//         var floorMaterial1 = new THREE.MeshLambertMaterial({color : 'lawngreen'});//'lawngreen'
//         var floorMesh1 = new THREE.Mesh(floorGeometry1, groundMaterial);
//         floorMesh1.position.set(s_*i+s_/2, 3, s_*j+s_/2);
//         floorMesh1.receiveShadow = true;
//         floorMesh1.rotation.x = - Math.PI / 2; 
//         scene.add(floorMesh1);
//     }
// } 


camera.position.set(1000*mSc, 300, 1000*mSc);
//camera.lookAt(floorMesh.position);

// Materials
const bulletMaterial = new THREE.MeshLambertMaterial( { color: 'gold' } );

const wallMaterial = new THREE.MeshLambertMaterial( { color: 'rgb(100,100,255)' } );
const wallMaterial_d = new THREE.MeshLambertMaterial( { color: 'rgb(100,100,255)', opacity: 0.8, transparent: true } );
const wallMaterial_t = new THREE.MeshLambertMaterial( { color: 'blue', opacity: 0.5, transparent: true } );
const editGridMaterial = new THREE.MeshLambertMaterial( { color: 'aqua' } );
const editSelectedGridMaterial = new THREE.MeshLambertMaterial( { color: 'grey' } );
const rockTexture = textureLoader.load('/static/image/stone_00007.jpg'); 
const rockMaterial = new THREE.MeshLambertMaterial( { map: rockTexture } );

const playerMaterial1 = new THREE.MeshLambertMaterial( { color: 'blue' } );
const playerMaterial2 = new THREE.MeshLambertMaterial( { color: 'red' } );
const playerMaterial3 = new THREE.MeshLambertMaterial( { color: 'yellow' }); //, opacity: 0.5, transparent: true } );
const playerMaterial3b = new THREE.MeshLambertMaterial( { color: 'grey' } );
const playerMaterialg = new THREE.MeshLambertMaterial( { color: 'black' } );
const playerMaterialf = new THREE.MeshBasicMaterial( { color: 'orange' } );
const faceTexture1 = textureLoader.load('/static/image/face20200525_001.png'); 
const faceMaterial1 = new THREE.MeshLambertMaterial( { map: faceTexture1, side: THREE.DoubleSide } );
const botTexture1 = textureLoader.load('/static/image/e0137995_18414394.jpg'); 
const botMaterial1 = new THREE.MeshLambertMaterial( { map: botTexture1 } );
const playerTexture1 = textureLoader.load('/static/image/skin-2933371_960_720.jpg'); 
const playerMaterialtx1 = new THREE.MeshLambertMaterial( { map: playerTexture1 } );
const paraTexture1 = textureLoader.load('/static/image/tatami_1.jpg'); 
const paraMaterial1 = new THREE.MeshLambertMaterial( { map: paraTexture1, side: THREE.DoubleSide } );

const textMaterial = new THREE.MeshBasicMaterial({ color: 0xf39800, side: THREE.DoubleSide });
const nicknameMaterial = new THREE.MeshBasicMaterial({ color: 'black', side: THREE.DoubleSide });
const bandageMaterial = new THREE.MeshLambertMaterial( { color: 'white' } );
const bandageMaterial2 = new THREE.MeshLambertMaterial( { color: 'red' } );
const potionMaterial = new THREE.MeshLambertMaterial( { color: 'blue' } );
const stormMaterial = new THREE.MeshLambertMaterial( { color: 'red', side: THREE.DoubleSide,opacity: 0.3, transparent: true } );

// Light
const light = new THREE.DirectionalLight(0xffffff, 1);
light.position.set(FIELD_WIDTH/2, FIELD_WIDTH, FIELD_HEIGHT/2);//(-100, 300, -100)
light.castShadow = true;
light.shadow.camera.left = -2000;
light.shadow.camera.right = 2000;
light.shadow.camera.top = 2000;
light.shadow.camera.bottom = -2000;
light.shadow.camera.far = 2000;
light.shadow.mapSize.width = 2048;
light.shadow.mapSize.height = 2048;
scene.add(light);

const light2 = new THREE.DirectionalLight(0xffffff, 1);
light2.position.set(FIELD_WIDTH/2, -FIELD_WIDTH, FIELD_HEIGHT/2);//(-100, 300, -100)
light2.castShadow = true;
light2.shadow.camera.left = -2000;
light2.shadow.camera.right = 2000;
light2.shadow.camera.top = 2000;
light2.shadow.camera.bottom = -2000;
light2.shadow.camera.far = 2000;
light2.shadow.mapSize.width = 2048;
light2.shadow.mapSize.height = 2048;
scene.add(light2);


const ambient = new THREE.AmbientLight(0x808080);
scene.add(ambient);

const loader = new THREE.FontLoader();
let font;
loader.load('/static/helvetiker_bold.typeface.json', function(font_) {
    font = font_;
});
        

// Helpers
// scene.add(new THREE.CameraHelper(light.shadow.camera));
// scene.add(new THREE.GridHelper(200, 50));
// scene.add(new THREE.AxisHelper(2000));
// scene.add(new THREE.DirectionalLightHelper(light, 20));

// Sound
//var music = new Audio('mymusic.mp3');
var ClickSound = new Audio("/static/sound/mBeam.wav");
var ShotSound1 = new Audio("/static/sound/sniperrifle--firing1.mp3");
var ShotSoundOthers1 =  ShotSound1.cloneNode();// new Audio("/static/sound/shotgun-firing1.mp3");
var ShotSound2 = new Audio("/static/sound/shotgun-firing1.mp3");
var ShotSound3 = new Audio("/static/sound/largerifle-firing1.mp3");
var EmptySound = new Audio("/static/sound/handgun-out-bullets1.mp3");　
var SetGunSound = new Audio("/static/sound/set-gun.mp3");　
var ReloadSound1 = new Audio("/static/sound/machinegun-slide1.mp3");
var ReloadSound2 = new Audio("/static/sound/shotgun-pumpaction1.mp3");
var ReloadSound3 = new Audio("/static/sound/largerifle-boltaction1.mp3");
var GiveDamageSound = new Audio("/static/sound/sword-clash4.mp3");//shot-struck1
var RecieveDamageSound = new Audio("/static/sound/stab.mp3");
var RemoveSound = new Audio("/static/sound/flee1.mp3");
var WallSetSound = new Audio("/static/sound/set-wall.mp3");
var WallDamageSound = new Audio("/static/sound/metal1.mp3"); //stab-wall
var UsedBandageSound = new Audio("/static/sound/recovery1.mp3");
var CannotUseBandageSound = new Audio("/static/sound/notcorrect1.mp3");
var ChurchSound = new Audio("/static/sound/church.mp3");
var GetItemSound = new Audio("/static/sound/puyon.mp3");
var EditSound = new Audio("/static/sound/gasyon.mp3");

function mSoundEffect(s_, vol_)
{
    s_.pause();
    s_.currentTime = 0;
    s_.volume = vol_;
    s_.play();
}

// model - human
THREE.Cache.enabled = true;
const modelLoader = new THREE.GLTFLoader();
//const mUrl = '/static/model/mKawaii.glb'; //s=50;
const mUrl = '/static/model/mRin.glb'; //s=50;

// Model gun
const gunLoader = new THREE.GLTFLoader();
const mGunUrl = '/static/model/uploads_files_2260928_sawed-off.glb';

let mixer;
let mModel = null;
let mArrayModel = [];
let mAnimations = null;
let mGun = null;
let mArrayGun = [];
var modelNum = 10;

for(var i=0;i<modelNum;i++)
{
    modelLoader.load(
        mUrl, 
        function ( gltf ){
            var s = 50;
            let m = gltf.scene;
            m.scale.set(s, s, s);
            mArrayModel.push(m);
            console.log("model loader:"+i);
        },
        function ( error ) {
            //console.log( 'An error happened' );
            //console.log( error );
        }
    );

    
    gunLoader.load(
        mGunUrl, 
        function ( gltf ){
            //mGun = gltf.scene;
            let g = gltf.scene;
            var s = 100;
            g.scale.set(s, s, s);
            //g.position.set(100,100,100);
            //scene.add( gltf.scene );
            mArrayGun.push(g);
            console.log("gun loader:"+i);
        },
        function ( error ) {
            //console.log( 'An error happened' );
            //console.log( error );
        }
    );

}// for


function mPlayModelAnimation(model_, animations_, flag_){

    console.log('mPlayModelAnimation');

    if(animations_ && animations_.length) {

        mixer = new THREE.AnimationMixer(model_);  
        let animation = animations_[0];
        let action = mixer.clipAction(animation) ;
        //action.setLoop(THREE.LoopOnce);
        action.clampWhenFinished = true;
        action.play();
        
        if(flag_==1){
            
        }
        else{
            action.stop();
            action.reset();
            //action.startAt(0);
            //mixer = null;
        }        
    }
}


//Pointer lock
function ElementRequestPointerLock(element){
    var list = [
        "requestPointerLock",
        "webkitRequestPointerLock",
        "mozRequestPointerLock"
    ];
    var i;
    var num = list.length;
    for(i=0;i < num;i++){
        if(element[list[i]]){
            element[list[i]]();
            return true;
        }
    }
    return false;
}

function DocumentExitPointerLock(document_obj){
    var list = [
        "exitPointerLock",
        "webkitExitPointerLock",
        "mozExitPointerLock"
    ];
    var i;
    var num = list.length;
    for(i=0;i < num;i++){
        if(document_obj[list[i]]){
            document_obj[list[i]]();
            return true;
        }
    }
    return false;
}


function mShowHelp(){
    $("#help-screen").toggle();
}
$("#help-screen").hide();

//Stats();
const stats = new Stats();
stats.showPanel(0);
document.body.appendChild(stats.dom);


var mID = '';
var mWeapon = 1;
var mIsZoom = 0;
var mMode = 1;
let movement = {};
$(document).on('keydown keyup', (event) => {
    const KeyToCommand = {
        'ArrowUp': 'forward',
        'ArrowDown': 'back',
        'ArrowLeft': 'left',
        'ArrowRight': 'right',
        'w': 'forward',
        's': 'back',
        'a': 'sideleft',
        'd': 'sideright',
    };
    const command = KeyToCommand[event.key];
    if(command){
        if(event.type === 'keydown'){
            movement[command] = true;
            //mPlayModelAnimation(mModel, mAnimations,1);
        }else{ /* keyup */
            movement[command] = false;
            //mPlayModelAnimation(mModel, mAnimations,0);
        }
        socket.emit('movement', movement);

        if(mMode==2){
            if(mNowTouboBuild == 1){
                socket.emit('doBuild');
            }    
        }//        

    }
    // if(event.key === ' ' && event.type === 'keydown'){
    //     socket.emit('shoot');        
    //     mSoundEffect(ShotSound1,1.0);
    // }
    if(event.key === 'q' && event.type === 'keydown'){
        socket.emit('buildWall');        
        //mSoundEffect(WallSetSound,1.0);
        mMode = 2;
    }
    if(event.key === 'z' && event.type === 'keydown'){
        socket.emit('buildFloor');        
        //mSoundEffect(WallSetSound,1.0);
        mMode = 2;
    }
    if(event.key === 'c' && event.type === 'keydown'){
        socket.emit('buildSlope');        
        //mSoundEffect(WallSetSound,1.0);
        mMode = 2;
    }
    if(event.key === 'Tab'  && event.type === 'keydown'){
        socket.emit('buildCone');    
        mMode = 2;   
    }
    if(event.key === 'y' && event.type === 'keydown'){
        socket.emit('jumper');        
    }
    //if(event.key === 'Control'  && event.type === 'keydown'){
    if(event.key === 'Shift'  && event.type === 'keydown'){
        socket.emit('squat');        
    }
    if(event.key === ' '  && event.type === 'keydown'){
        socket.emit('jump');        
    }
    if(event.key === '1'  && event.type === 'keydown'){
        socket.emit('modeChanged', 1);
        mMode = 1;
        socket.emit('weaponChange',1);  
        mWeapon = 1; 
        mSoundEffect(SetGunSound,1.0);    
    }
    if(event.key === '2'  && event.type === 'keydown'){
        socket.emit('modeChanged', 1);
        mMode = 1;
        socket.emit('weaponChange',2);     
        mWeapon = 2;   
        mSoundEffect(SetGunSound,1.0);
    }
    if(event.key === '3'  && event.type === 'keydown'){
        socket.emit('weaponChange',3);       
        mWeapon = 3; 
        mSoundEffect(SetGunSound,1.0);
        socket.emit('modeChanged', 1);
        mMode = 1;
    }
    if(event.key === '4'  && event.type === 'keydown'){
        socket.emit('weaponChange',4);       
        mWeapon = 4; 
        socket.emit('modeChanged', 1);
        mMode = 1;
    }
    if(event.key === '5'  && event.type === 'keydown'){
        socket.emit('weaponChange',5);       
        mWeapon = 5;
        socket.emit('modeChanged', 1);
        mMode = 1; 
    }
    if( ((event.key === 'r') || (event.key === 'j')) && event.type === 'keydown'){
        socket.emit('reload');
        if(mWeapon==1){
            mSoundEffect(ReloadSound1,1.0);
        }
        if(mWeapon==2){
            mSoundEffect(ReloadSound2,1.0);
        }
        if(mWeapon==3){
            mSoundEffect(ReloadSound3,1.0);
        }
    }
    if(event.key === 'f'  && event.type === 'keydown'){
        socket.emit('modeChanged', 1);
        mMode = 1;       

        //mPlayModelAnimation(mModel, mAnimations);
    }
    if(event.key === 'b'  && event.type === 'keydown'){
        socket.emit('emote');       
    }
    if(event.key === 'e'  && event.type === 'keydown'){
        socket.emit('edit');       
    }


    if(event.key === 'p'  && event.type === 'keydown'){
        ElementRequestPointerLock(canvas2d);
    }
    if(event.key === 'h'  && event.type === 'keydown'){
        mShowHelp();
    }

});

//--- Mouse event ---//
var mShootCount = 0;
var mNowTouboBuild = 0;
var mNowSelectGrid = 0;

canvas2d.addEventListener('mousedown', function(e)
{
    if(mMode==1){
        if(e.button==0){
            if(mWeapon<=3){
                movement['shoot'] = true;
                socket.emit('movement', movement);    
            }
            else if(mWeapon==4){
                socket.emit('useBandage', 1);
            }
            else if(mWeapon==5){
                socket.emit('usePotion', 1);
            }
        }//    
        else if(e.button==2){
            camera.zoom = 2;
            if(mWeapon ==3){
                camera.zoom = 10;
            }
            camera.updateProjectionMatrix();
        }  
        
    }//
    else if(mMode==2){
        if(e.button==0){
            socket.emit('doBuild');   
        }
    }
    else if(mMode==3){
        if(e.button==0){
            socket.emit('startSelectGrid'); 
            mNowSelectGrid = 1;
        }

        if(e.button==2){
            socket.emit('resetSelectGrid'); 
        }
    }


    if(e.button==0){
        mNowTouboBuild = 1;
        socket.emit('nowTouboBuild', 1);
    }

    if(e.button==3){
        socket.emit('modeChanged', 1);
        mMode = 1;
        socket.emit('weaponChange',1);  
        mWeapon = 1; 
        mSoundEffect(SetGunSound,1.0);
    }
    else if(e.button==4){
        socket.emit('modeChanged', 1);
        mMode = 1;
        socket.emit('weaponChange',2);  
        mWeapon = 2; 
        mSoundEffect(SetGunSound,1.0);
    }
    else if(e.button==5){

    }


});

canvas2d.addEventListener('mouseup', function(e)
{
    if(e.button==0){
        movement['shoot'] = false;
        socket.emit('movement', movement);

        mNowTouboBuild = 0;
        socket.emit('nowTouboBuild', 0);

        if(mMode==3){
            socket.emit('finishSelectGrid'); 
            mNowSelectGrid = 0;
        }

    }//

    if(e.button==2){
        camera.zoom = 1;
        camera.updateProjectionMatrix();
    }

});

var mLastMouseX = 0;
var mLastMouseY = 0;
var mMouseSenseX = 0.001;
var mMouseSenseY = 0.001;

canvas2d.addEventListener('mousemove', function(e)
{
    var ang_ = (e.movementX) * mMouseSenseX * 3.1415/2;
    var ang2_ = (e.movementY) * mMouseSenseY * 3.1415/2;
    
    if(camera.zoom!=1){
        ang_ *= 0.5;
        ang2_ *= 0.5;
    }

    socket.emit('mousemoveX', ang_);
    socket.emit('mousemoveY', ang2_);    
    //console.log('ang_:'+ang_+' movement:'+e.movementX);  

    if(mMode==2){
        if(mNowTouboBuild == 1){
            socket.emit('doBuild');
        }    
    }

    if(mMode==3){
        if(mNowSelectGrid == 1){
            socket.emit('nowSelectGrid');
        }    
    }
    
});


canvas2d.addEventListener('mousewheel', function(e)
{
    var v_ = e.wheelDelta;
    if(v_<0){ // down(win)    up(mac)
       
        socket.emit('buildFloor');
        mMode = 2;
    }
    if(v_>0){ //up(win)  down(mac)
       
        socket.emit('buildSlope');
        mMode = 2;
    }
    console.log('wheel:'+v_);  
});


$("#canvas-load").show();

var mTimer;
mTimer = setInterval(() => {
    //console.log('FPS:'+ 1000.0/(performance.now() - mTime_)  );

    var v = 0;
    for(var i=0;i<modelNum;i++)
    {
        if(mArrayModel[i]){
            v+=1;
        }
    }//
    console.log('model:'+v );

    mDrawLoad(v);

    if(v==10){
        $("#canvas-load").hide();
        clearInterval(mTimer);
        console.log('Timer cleared.');
        $("#start-screen").show();
    }
    
}, 1000);




function gameStart(){
    const nickname = $("#nickname").val();
    socket.emit('game-start', {nickname: nickname});
    $("#start-screen").hide();
    $("#canvas-vic").hide();
    $("#help-screen").hide();
    $("#canvas-load").hide();

    socket.emit('skinIsLoaded');

    //mGameStarted = 1;
    //animate();

    
    if(mDeviceType=='Mobile'){
        mCreateMobileGUI();
        $("#canvas-mob").show();
        mSoundEffect(ShotSound1,vol_);
    }

    ElementRequestPointerLock(canvas2d);

}
$("#start-button").on('click', gameStart);



var mFontSize1 = Math.floor(canvas2d.width/100);
var mFontSize2 = mFontSize1*2;
var mDisplayDamage = 0;
const Meshes = [];
let clock = new THREE.Clock();
var mTime_ = performance.now();

setInterval(() => {
    //console.log('FPS:'+ 1000.0/(performance.now() - mTime_)  );
    mTime_ = performance.now();
    socket.emit('mousemoveX', 0);
}, 1000/200);


function mLoadSkin(){

    let model_ = null;
    modelLoader.load(
        mUrl, 
        function ( gltf ){
            var s = 50;
            model_ = gltf.scene;
            model_.scale.set(s, s, s);
        },
        function ( error ) {
            console.log( 'An error happened' );
            console.log( error );
        }
    );

    while(!model_){
        console.log( 'Waiting load...');
    }
    console.log( 'Model:'+model_ );   

    return model_;
}//


socket.on('state', (mGlobalTime, players, bullets, walls, floors, slopes, cones, triangles, bandages, potions, mStorm) => {

    //console.log('time:'+ (performance.now() - mTime_) +'[ms]' );
    //console.log('FPS:'+ 1000.0/(performance.now() - mTime_)  );
    ///mTime_ = performance.now();


    var mGameStarted = 0;

    Object.values(players).forEach((player) => {

        if(player.socketId === socket.id){
            //console.log('player.isSkinLoaded:'+player.isSkinLoaded);
            if(player.isSkinLoaded==1){
                mGameStarted = 1;
            }
        }
    });

    if(mGameStarted==0){
        return;
    }
    //console.log('mGameStarted:'+mGameStarted);

    //animate();
    renderer.render( scene, camera );

    stats.update();

    Object.values(Meshes).forEach((mesh) => {mesh.used = false;});
    
    var W_ = canvas2d.width;
    var H_ = canvas2d.height;
    context.clearRect(-W_/2, -H_/2, W_*2, H_*2);

    //Device
    context.font = mFontSize1+'px Bold Arial'; //'20px Bold Arial';
    context.fillStyle="black";
    context.fillText( mDeviceType+':'+screen.availWidth, W_/4, mFontSize1*1.5);
 

    
    //var i_player = 0;
    var p_ = 0;
    // Players
    Object.values(players).forEach((player) => {

        var px = player.y;// 
        var py = player.z;
        var pz = player.x;// 

        var coA_ =-3.1415/180.0*30.0;
        var pL_ = player.tall/3;
        var pW_ = player.tall/2;
        var pW2_ = pL_/3; //pL_/2;
        var A_ = 3.1415/10;
        var pA_ = A_;
        var ofz_ = 0; //pW_/2;// * 2;
        var pang_ = player.angle;
        var pa2_ = player.angle2;
        var ofx_ = 0; //pW_/4 + 15; //pW_/2; //0; //200 * Math.sin(-pa2_) * 0;
        var sq_ = player.isSquat;
        var hGun = player.tall*0.75;

        let playerMesh = Meshes[player.id];
        if(!playerMesh){

            console.log('create player mesh:'+p_);
            playerMesh = new THREE.Group();
    		playerMesh.castShadow = true;
    		Meshes[player.id] = playerMesh;
    		scene.add(playerMesh);

            var k = player.order;
            console.log('k:'+k);
            mArrayModel[k].name = 'bodySkin';
            mArrayModel[k].position.set(ofx_,0,0);
            playerMesh.add( mArrayModel[k] );
            console.log('                 :'+mArrayModel[k].name);


            mArrayGun[k].name = 'shotGun';
            mArrayGun[k].position.set(-15,hGun,25);
            mArrayGun[k].rotation.y = Math.PI/2*0.9; 
            playerMesh.add( mArrayGun[k] );

        }
        playerMesh.used = true;
        // var pz = player.tall;
        // if(player.isSquat==1){
        //     pz = player.tall / 2;
        // }
        playerMesh.position.set(px, py, pz);
        playerMesh.rotation.y =  player.angle;
        
        var Ang_R_LowerLeg = 0;
        var Ang_L_LowerLeg = 0;
        var pArest_ = 0;
        if(player.isMoving==1){
            var tang = 40;
            pA_ = A_ * Math.sin( player.timeCount/tang*3.1415*2.0);
        //     //console.log('timeCount:'+player.timeCount);
            //Ang_L_LowerLeg = A_ * Math.sin( player.timeCount/tang*3.1415*2.0) + A_;
            //Ang_R_LowerLeg = A_ * Math.cos( player.timeCount/tang*3.1415*2.0) + A_;
        }
        else{
            pArest_ = A_/5 * Math.sin( player.timeCount/120.0*3.1415*2.0);
        }

        if(player.socketId !== socket.id){
            ofx_ = 0;
            ofz_ = 0;
        }
        

        let playerMat_ = playerMaterialtx1;
        if(player.isBot==1){
            playerMat_ = botMaterial1;
        }

        let mesh0 = playerMesh.getObjectByName('bodyOrigin')
        if(mesh0){
            playerMesh.remove(mesh0);
            mesh0.geometry.dispose();
            mesh0 = null;
        }
        mesh = new THREE.Mesh(new THREE.BoxGeometry(pL_/4, pL_/4, pL_/4), playerMat_);
        mesh.position.set(0,0,0);
        
        mesh.castShadow = true;
        mesh.name = 'bodyOrigin';
        playerMesh.add(mesh);

        mUseSkin = 1;

        // Skin
        if( (mUseSkin==1) ) { //if(player.socketId === socket.id){

            // if(mixer){
            //     mixer.update(clock.getDelta()*5);
            //     //console.log('mixer:'+mixer.time);
        
            //     // if(mixer.time>1.0){
            //     //     mixer.setTime(0);
            //     // }
            // }

            let meshg = playerMesh.getObjectByName('shotGun');
            if(meshg){
                meshg.rotation.x = player.angle2;
                var tg = player.timeCount - player.firingTime; 
                var tgL = 30;
                var a_ = -2*Math.PI;
                if(player.weapon==1){
                    tgL = 5;
                    a_ = -Math.PI/30;
                }
                if( tg < tgL ){
                    meshg.rotation.x = a_ * tg / tgL; 
                }//
    
                meshg.position.y = hGun;
                if(player.isSquat==1){
                    meshg.position.y = hGun * 0.7;
                }    
            }

            //console.log('movement:'+ movement.forward );

            //--- kawaii
            // var mJ_Neck = "J_Bip_C_Neck";
            // var mJ_Chest = "J_Bip_C_Chest";
            // var mJ_R_Shoulder = "J_Bip_R_Shoulder";
            // var mJ_L_Shoulder = "J_Bip_L_Shoulder";
            // var mJ_R_UpperArm = "J_Bip_R_UpperArm";
            // var mJ_L_UpperArm = "J_Bip_L_UpperArm";
            // var mJ_R_LowerArm = "J_Bip_R_LowerArm";
            // var mJ_L_LowerArm = "J_Bip_L_LowerArm";
            // var mJ_R_UpperLeg = "J_Bip_R_UpperLeg";
            // var mJ_L_UpperLeg = "J_Bip_L_UpperLeg";
            // var mJ_R_LowerLeg = "J_Bip_R_LowerLeg";
            // var mJ_L_LowerLeg = "J_Bip_L_LowerLeg";

            //--- Rin
            var mJ_Neck = "Neck";
            var mJ_Chest = "Chest";
            var mJ_Spine = "Spine";
            var mJ_R_Shoulder = "Right_shoulder";
            var mJ_L_Shoulder = "Left_shoulder";
            var mJ_R_UpperArm = "Right_arm";
            var mJ_L_UpperArm = "Left_arm";
            var mJ_R_LowerArm = "Right_elbow";
            var mJ_L_LowerArm = "Left_elbow";
            var mJ_R_UpperLeg = "Right_leg";
            var mJ_L_UpperLeg = "Left_leg";
            var mJ_R_LowerLeg = "Right_knee";
            var mJ_L_LowerLeg = "Left_knee";


            let mesh1 = playerMesh.getObjectByName('bodySkin');
            if(mesh1)
            {
                mesh1.traverse(function(obj) {

                    //console.log('obj.name:'+obj.name);
                    mesh1.position.set(0,0,0);
                    if(player.isSquat==1){
                        
                    }
                
                    //--- Default
                    if( (obj.name == mJ_R_Shoulder)  ){
                        obj.rotation.x = -Math.PI/2;
                    }
                    else if( (obj.name == mJ_L_Shoulder)  ){
                        obj.rotation.x = -Math.PI/2;
                    }
                    else if( (obj.name == mJ_R_UpperArm)  ){
                    }
                    else if( (obj.name == mJ_R_LowerArm)  ){
                        //obj.rotation.order = "XYZ";
                        //obj.rotation.set(Math.PI/2, 0, 0); //roll
                        //obj.rotation.set(0, Math.PI/2, 0); //pitch
                        //obj.rotation.set(0, 0, Math.PI/2); //yow
                        //obj.rotation.set(Math.PI/2*0.8, 0, -Math.PI/2*1.2);
                        obj.rotation.order = "ZYX";
                        obj.rotation.set(0.0, Math.PI/2, Math.PI/2*1.1);
                        //const a = new THREE.Euler( 1.57, 0, 0, 'XYZ' );
                        //obj.position.applyEuler(a);
                    }
                    else if( (obj.name == mJ_L_UpperArm)  ){
                        obj.rotation.order = "ZXY";
                        obj.rotation.set(-Math.PI/2*0.1, -Math.PI/2*1.0, -Math.PI/2*1.4);
                    }
                    else if( (obj.name == mJ_R_UpperLeg)  ){
                        obj.rotation.z = 0;
                    }
                    else if( (obj.name == mJ_L_UpperLeg)  ){
                        obj.rotation.z = 0;
                    }
                    else if( (obj.name == mJ_Spine)  ){
                        obj.rotation.x = Math.PI/2*0.1;
                    }
                    else if( (obj.name == mJ_Neck)  ){
                        obj.rotation.x = 0;
                    }

                    //--- Squat
                    if(player.isSquat==1){
                        if( (obj.name == mJ_Spine)  ){
                            obj.rotation.x = Math.PI/2;
                        }
                        else if( (obj.name == mJ_Neck)  ){
                            obj.rotation.x = -Math.PI/3;
                        }
                        else if( (obj.name == mJ_R_Shoulder)  ){
                            obj.rotation.x = -Math.PI*0.9;
                        }
                        else if( (obj.name == mJ_L_Shoulder)  ){
                            obj.rotation.x = -Math.PI*0.9;
                        }
                    }

                    //--- Motion
                    if( (player.isMoving==0) && (player.isGrounded==1) && (player.isEmote==0) ){
                        if( (obj.name == mJ_Chest)  ){  //mJ_Chest
                            //obj.rotation.x = pArest_;
                        }
                        else if( (obj.name == mJ_R_UpperLeg) ){
                            obj.rotation.x = Math.PI;
                        }
                        else if( (obj.name == mJ_R_LowerLeg) ){
                            obj.rotation.x = 0;
                        }
                        else if( (obj.name == mJ_Neck) ){
                            obj.rotation.y = 0;
                        }
                    }
                    else if( (player.isMoving==1) && (player.isGrounded==1) ){
                        if( (obj.name == mJ_Neck) ){
                            //obj.rotation.z = pA_/2;
                            obj.rotation.order = "XYZ";
                            //obj.rotation.set(pA_/2, 0, 0);
                        }
                        else if( (obj.name == mJ_R_UpperLeg) ){
                            obj.rotation.x = pA_+Math.PI;
                        }
                        else if( (obj.name == mJ_L_UpperLeg)  ){
                            obj.rotation.x = -pA_+Math.PI;
                        }
                        else if( (obj.name == mJ_R_LowerLeg)  ){
                            obj.rotation.x = Ang_R_LowerLeg;;
                        }
                        else if( (obj.name == mJ_L_LowerLeg)  ){
                            obj.rotation.x = Ang_L_LowerLeg;
                        }
                    }
                    else if( (player.isGrounded==0) ){ //(player.isJump==1)
                        if( (obj.name == mJ_R_UpperLeg)  ){
                            obj.rotation.x = Math.PI/2*0.8;
                            obj.rotation.z = Math.PI*0.2;
                        }
                        else if( (obj.name == mJ_R_LowerLeg) ){
                            obj.rotation.x = Math.PI/2*1.5;
                        }
                        else if( (obj.name == mJ_L_UpperLeg)  ){
                            obj.rotation.x = Math.PI/2*1.2;
                            obj.rotation.z = -Math.PI*0.2;
                        }
                        else if( (obj.name == mJ_L_LowerLeg) ){
                            obj.rotation.x = Math.PI/2*1.5;
                        }
                    }
                    else if( (player.isMoving==0) && (player.isGrounded==1) && (player.isEmote==1) ){
                        if( (obj.name == mJ_Neck) ){
                            obj.rotation.y = -Math.PI*0.8;
                        }
                    }

                });
            }//if

        }// skin == 1


        var gL_ = pL_*2;
        var gW_ = pL_/4;
        if(player.weapon==2){
            gW_ = pL_/2;
        }
        else if(player.weapon==3){
            gL_ = pL_*4;
        }

        let meshG = playerMesh.getObjectByName('bodyG');
        if(meshG){
            playerMesh.remove(meshG);
            meshG.geometry.dispose();
            meshG = null;
        }


        if( (mUseSkin==0) ) //(player.socketId !== socket.id) (player.isBot == 1) ||
        {
            let mesh1 = playerMesh.getObjectByName('bodyL1');
            if(mesh1){
                playerMesh.remove(mesh1);
                mesh1.geometry.dispose();
                mesh1 = null;
            }
            mesh = new THREE.Mesh(new THREE.BoxGeometry(pW2_, pL_, pL_/4), playerMat_);
            mesh.position.set(pW2_+ofx_, pL_/2, ofz_);
            //mesh.rotation.z = - pA_;
            mesh.rotation.x = - pA_;
            
            mesh.castShadow = true;
            mesh.name = 'bodyL1';
            playerMesh.add(mesh);

            let mesh2 = playerMesh.getObjectByName('bodyL2');
            if(mesh2){
                playerMesh.remove(mesh2);
                mesh2.geometry.dispose();
                mesh2 = null;
            }
            mesh = new THREE.Mesh(new THREE.BoxGeometry(pW2_, pL_, pL_/4), playerMat_);
            mesh.position.set(-pW2_/2-pL_/5+ofx_, pL_/2, ofz_);
            //mesh.rotation.z =  pA_;
            mesh.rotation.x =  pA_;
            mesh.castShadow = true;
            mesh.name = 'bodyL2';
            playerMesh.add(mesh);
            

            let meshB = playerMesh.getObjectByName('body');
            if(meshB){
                playerMesh.remove(meshB);
                meshB.geometry.dispose();
                meshB = null;
            }
            mesh = new THREE.Mesh(new THREE.BoxGeometry(pL_*0.7, pL_, pL_/3), playerMat_);
            mesh.position.set(ofx_,pL_/2+pL_-pL_/2*sq_,0+ofz_);
            mesh.rotation.y = -3.1415/4 * (1.0 - sq_);//-3.1415/4;
            mesh.rotation.x = 3.1415/3*sq_;
            mesh.castShadow = true;
            mesh.name = 'body';
            playerMesh.add(mesh);

            let meshA1 = playerMesh.getObjectByName('bodyA1');
            if(meshA1){
                playerMesh.remove(meshA1);
                meshA1.geometry.dispose();
                meshA1 = null;
            }
            var pAS_ = pL_/4;
            mesh = new THREE.Mesh(new THREE.BoxGeometry(pAS_, pAS_, pL_), playerMat_);
            mesh.position.set(-pAS_/2-pW_/4+ofx_,pL_*2-pL_/4-pL_*sq_,pL_/4);
            mesh.rotation.y = 0;
            //mesh.rotation.z = -player.angle2;
            mesh.rotation.x = player.angle2;
            mesh.castShadow = true;
            mesh.name = 'bodyA1';
            playerMesh.add(mesh);

            let meshA2 = playerMesh.getObjectByName('bodyA2');
            if(meshA2){
                playerMesh.remove(meshA2);
                meshA2.geometry.dispose();
                meshA2 = null;
            }
            mesh = new THREE.Mesh(new THREE.BoxGeometry(pAS_, pAS_, pL_), playerMat_);
            mesh.position.set(ofx_,pL_*2-pL_/4-pL_*sq_, pW_/2+ofz_);
            mesh.rotation.y = -3.1415/4;;
            mesh.castShadow = true;
            mesh.name = 'bodyA2';
            playerMesh.add(mesh);


            let playerMat3_ = playerMaterial3;
            if(player.isBot==1){
                playerMat3_ = playerMaterial3b;
            }
            let meshH = playerMesh.getObjectByName('bodyH');
            if(meshH){
                playerMesh.remove(meshH);
                meshH.geometry.dispose();
                meshH = null;
            }
            var pHS_ = pL_*0.6;
            mesh = new THREE.Mesh(new THREE.BoxGeometry(pHS_, pHS_, pHS_), playerMat3_);
            //mesh.position.set(ofx_+pL_/2*sq_, pL_/2+pL_*2 -pL_*sq_ ,+ofz_);
            mesh.position.set(ofx_ , pL_/2+pL_*2 -pL_*sq_ , ofz_+ pL_/2*sq_ );
            mesh.rotation.y = 0;
            if(player.isEmote == 1){
                mesh.rotation.y = 3.1415 - coA_;
            }
            mesh.castShadow = true;
            mesh.name = 'bodyH';
            playerMesh.add(mesh);

            if(player.isBot==0){

                let meshFace = playerMesh.getObjectByName('bodyFace');
                if(meshFace){
                    playerMesh.remove(meshFace);
                    meshFace.geometry.dispose();
                    meshFace = null;
                }
                meshFace = new THREE.Mesh(new THREE.PlaneGeometry(pHS_, pHS_, 1, 1), faceMaterial1); //playerMaterial3); //
                
                meshFace.position.set(ofx_ , pL_/2+pL_*2 -pL_*sq_ ,+pHS_/2+ofz_ );
                meshFace.rotation.y = 0; //3.1415/2;
                if(player.isEmote == 1){
                    meshFace.position.set(ofx_+pHS_/2*1.01*Math.sin(coA_), pL_/2+pL_*2 -pL_*sq_ ,+ofz_+pHS_/2*1.01*Math.cos(3.1415+coA_) +pL_/2*sq_ );
                    meshFace.rotation.y = 3.1415/2*0 - coA_;
                } 
                //meshFace.castShadow = true;
                meshFace.name = 'bodyFace';
                playerMesh.add(meshFace);
            }

            if(player.weapon<=3){
                mesh = new THREE.Mesh(new THREE.BoxGeometry(gW_, gW_, gL_), playerMaterialg);
                mesh.position.set(-pW_/4+ofx_ ,pL_*2 - pL_*sq_ +gL_/2*Math.sin(-pa2_), (pL_+gL_/2)*Math.cos(pa2_) + ofz_);
                mesh.rotation.y = 0;
                mesh.rotation.x = pa2_;
                mesh.castShadow = true;
                mesh.name = 'bodyG';
                playerMesh.add(mesh);    
            }
            
        }//if
        

        if((player.weapon==4) && (player.bandages>0) ){
            mesh = new THREE.Mesh(new THREE.CylinderGeometry(gW_,gW_,gW_*2,10,10,false), bandageMaterial); 
            mesh.position.set(ofx_+gL_/2*Math.cos(pa2_) ,pL_*2 -pL_*sq_ +gL_/2*Math.sin(-pa2_), pW_/2+ ofz_);
            mesh.rotation.y = 0;
            mesh.rotation.z = -pa2_;
           
            mesh.name = 'bodyG';
            playerMesh.add(mesh);    
        }
        else if( (player.weapon==5) && (player.potions>0) ){
            mesh = new THREE.Mesh(new THREE.CylinderGeometry(gW_,gW_,gW_*2,10,10,false), potionMaterial); 
            mesh.position.set(ofx_+gL_/2*Math.cos(pa2_) ,pL_*2 -pL_*sq_ +gL_/2*Math.sin(-pa2_), pW_/2+ ofz_);
            mesh.rotation.y = 0;
            mesh.rotation.z = -pa2_;
            
            mesh.name = 'bodyG';
            playerMesh.add(mesh);    
        }


        let meshF = playerMesh.getObjectByName('bodyF');
        if(meshF){
            playerMesh.remove(meshF);
            meshF.geometry.dispose();
            meshF = null;
        }
        
        if(player.timeCount - player.firingTime < 5){
            mesh = new THREE.Mesh(new THREE.BoxGeometry(gW_*3, gW_*3,2), playerMaterialf);
            //mesh.position.set(-pW_/4+ofx_, pL_*2 -pL_*sq_ +gL_*Math.sin(-pa2_), gL_*Math.cos(pa2_) + ofz_);
            mesh.position.set(-20, player.tall*0.75 -pL_*sq_ +gL_*Math.sin(-pa2_), gL_*Math.cos(pa2_) + ofz_);
            
            mesh.rotation.y = 0;
            mesh.rotation.x = pa2_;
            mesh.rotation.z = Math.random()* 3.1415 / 2;
            mesh.castShadow = true;
            mesh.name = 'bodyF';
            playerMesh.add(mesh);    
        }

        let meshP = playerMesh.getObjectByName('bodyP');
        if(meshP){
            playerMesh.remove(meshP);
            meshP.geometry.dispose();
            meshP = null;
        }
        if(player.mode==0){
            //mesh = new THREE.Mesh(new THREE.PlaneGeometry(pL_*2, pL_*8, 1,1), paraMaterial1);
            mesh = new THREE.Mesh(new THREE.BoxGeometry(pL_*2, pL_/4, pL_*8), paraMaterial1);
            mesh.position.set(ofx_, pL_*4, ofz_);
            //mesh.rotation.x = Math.PI/2;
            mesh.castShadow = true;
            mesh.name = 'bodyP';
            playerMesh.add(mesh);    
        }


        // buildTemp
        if(player.socketId === socket.id){
            if(player.buildTemp)
            { 
                let wallt = player.buildTemp;
                let walltMesh = Meshes[wallt.id];
                if(!walltMesh)
                {
                    if(player.buildType<=2)
                    {
                        //console.log('walltMesh');
                        walltMesh = new THREE.Mesh(new THREE.BoxGeometry(wallt.Ly, wallt.Lz, wallt.Lx), wallMaterial_t);
                        var wx = wallt.y + wallt.Ly/2;
                        var wy = wallt.z + wallt.Lz/2;
                        var wz = wallt.x + wallt.Lx/2;
                        if(player.buildType==2){
                            wx = wallt.y + mFieldGridSize/2;
                            wy = wallt.z - wallt.Lz/2;
                            wz = wallt.x + mFieldGridSize/2;
                        }
                        walltMesh.position.set(wx, wy, wz);
                        
                        if(player.buildType==2){
                            
                            if((wallt.angle == 3.1415/2)||(wallt.angle == 3.1415/2*3) ){
                                walltMesh.rotation.z = -wallt.angle2;
                            }    
                            else{
                                walltMesh.rotation.x = wallt.angle2;
                            }
                        }
                    }
                    else if(player.buildType==3){

                        //console.log('walltMesh cone');
                        walltMesh = new THREE.Group();
                        let geometry = new THREE.Geometry();
                        geometry.castShadow = true;

                        let P =  wallt.P;
                        let F =  wallt.F;
                        //console.log('cone.P:'+P);

                        for(var i=0;i<5;i++){ //y,z,x
                            geometry.vertices[i] = new THREE.Vector3(P[i][1], P[i][2], P[i][0]);
                        }
                        // geometry.faces[0] = new THREE.Face3(0,1,2);//counter clock wise
                        // geometry.faces[1] = new THREE.Face3(0,2,1);//back side
                        for(var i=0;i<4;i++){
                            geometry.faces[i*2+0] = new THREE.Face3(F[i][0],F[i][1],F[i][2]);//counter clock wise
                            geometry.faces[i*2+1] = new THREE.Face3(F[i][0],F[i][2],F[i][1]);//back side            
                        }
                        geometry.computeFaceNormals();

                        var Triangle =  new THREE.Mesh(geometry,wallMaterial_t);
                        Triangle.castShadow = true;
                        walltMesh.add(Triangle);
                        walltMesh.castShadow = true;

                //     Meshes[cone.id] = coneMesh;
                //     scene.add(coneMesh);

                    }// else if

                    Meshes[wallt.id] = walltMesh;
                    scene.add(walltMesh);
                }

                if(player.mode == 2){
                    walltMesh.used = true;
                    //console.log('walltMesh used');
                }
                
            }//if(!walltMesh)
        }

        
        if(font){
            if(!playerMesh.getObjectByName('nickname'))
            {
                //console.log('create nickname mesh');
                if(player.socketId !== socket.id){
                    let meshN = playerMesh.getObjectByName('nickname');

                    if(!meshN){
                        meshN = new THREE.Mesh(
                            new THREE.TextGeometry(player.nickname,
                                {font: font, size: 10, height: 1}),
                                nicknameMaterial,
                        );
                        meshN.name = 'nickname';
                        playerMesh.add(meshN);    
                    }
                    meshN.position.set(0, player.tall+20, 0);
                    meshN.rotation.y = -Math.PI/2;
                }
            }
            {
                // if(player.socketId !== socket.id)
                // {
                //     let mesh = playerMesh.getObjectByName('health');

                //     if(mesh && mesh.health !== player.health){
                //         playerMesh.remove(mesh);
                //         mesh.geometry.dispose();
                //         mesh = null;
                //     }
                //     if(!mesh){
                //         //console.log('create health mesh');
                //         mesh = new THREE.Mesh(
                //             new THREE.TextGeometry('*'.repeat(player.health),
                //                 {font: font, size: 10, height: 1}),
                //                 textMaterial,
                //         );
                //         mesh.name = 'health';
                //         mesh.health = player.health;
                //         playerMesh.add(mesh);
                //     }
                //     mesh.position.set(0, player.tall, 0);
                //     mesh.rotation.y = -Math.PI/2;
                // }//
            }
        }
        
        
        
        if(player.socketId === socket.id){
            // Your player
            var dx_ = player.cameraPosition[1];
            var dy_ = player.cameraPosition[2];
            var dz_ = -player.cameraPosition[0]; //150; //90;//170; //far
            //var coA_ =-3.1415/8.0;

            // Camera
			camera.position.set(
			    // px - d_ * Math.cos(player.angle +coA_) * Math.cos(pa2_),
			    // py + (player.tall -player.tall/2*sq_)*0.8 + d_*Math.sin(pa2_),
                // pz - d_ * Math.sin(player.angle+coA_) * Math.cos(pa2_) 

                // px - (dz_ * Math.sin(pa_) + dx_ * Math.cos(pa_) ) * Math.cos(pa2_),
			    // py + (player.tall -player.tall/2*sq_)*0.8 + d_*Math.sin(pa2_),
                // pz - (dz_ * Math.cos(pa_) + dx_ * Math.sin(pa_) ) * Math.cos(pa2_)

                // px - (dz_ * Math.sin(player.angle) + dx_ * Math.cos(player.angle) ) * Math.cos(pa2_),
			    // py + (player.tall -player.tall/2*sq_)*0.8 + dz_*Math.sin(pa2_),
                // pz - (dz_ * Math.cos(player.angle) - dx_ * Math.sin(player.angle) ) * Math.cos(pa2_)

                px - (dz_ * Math.sin(player.angle) * Math.cos(pa2_) - dx_ * Math.cos(player.angle) ) ,
			    py + dy_ + dz_*Math.sin(pa2_),
                pz - (dz_ * Math.cos(player.angle) * Math.cos(pa2_) + dx_ * Math.sin(player.angle) ) 
                );
            //camera.rotation.set(0, - player.angle - Math.PI/2, 0);
            // camera.rotation.x = 0;
            // camera.rotation.y = - player.angle - Math.PI/2;
            // camera.rotation.x = 0.0;

            //camera.rotation.order = "XYZ";
            camera.rotation.order = "YXZ";
            //camera.rotation.x = 0;
            camera.rotation.y =  player.angle + Math.PI;// - Math.PI/2;
            camera.rotation.x = - player.angle2;
            //camera.rotation.x = 3.1415/4;
            //camera.rotation.set(0, 0, 0.1);
            //camera.rotation.order = "XYZ"

            // Write to 2D canvas
            var x_,y_,w_,w2_,h_;
            
            // Scope
            if( (mWeapon==3) && (camera.zoom != 1) )
            {    
                context.strokeStyle="black";
                var r_ = W_/2*0.52;
                context.lineWidth = 1;
                context.beginPath();
                context.arc(W_/2, H_/2, r_, 0, Math.PI*2, false);
                context.closePath();
                context.stroke();

                r_ = W_/2*0.6;
                context.lineWidth = 50;
                context.beginPath();
                context.arc(W_/2, H_/2, r_, 0, Math.PI*2, false);
                context.closePath();
                context.stroke();
                
                context.lineWidth = 1;
                context.beginPath();
                context.moveTo(W_/2, H_/2-r_);
                context.lineTo(W_/2, H_/2+r_);
                context.closePath();
                context.stroke();
            }
            //else{
                var s_ = W_/30;
                context.strokeStyle="black";
                context.lineWidth = 2;
                context.beginPath();
                context.setLineDash([5,10]);
                context.moveTo(W_/2, H_/2-s_);
                context.lineTo(W_/2, H_/2+s_);
                context.closePath();
                context.stroke();
                context.beginPath();
                context.moveTo(W_/2-s_, H_/2);
                context.lineTo(W_/2+s_, H_/2);
                context.closePath();
                context.stroke();

                context.setLineDash([]);
            //}

            // Player angle
            x_ = canvas2d.width / 2;
            y_ = mFontSize2;
            context.font = mFontSize2 + 'px Bold Arial';
            context.fillStyle="black";
            context.fillText( Math.floor(player.angle/3.1415*180), x_, y_);

            y_ = mFontSize2*2;
            context.fillText( Math.floor(-player.angle2/3.1415*180), x_, y_);

            // life gauge
            context.strokeStyle = 'black';
            context.fillStyle='green'; 
            if(player.inStorm==1){
                context.fillStyle='red';
            }
            w_ = canvas2d.width / 4;
            w2_ = canvas2d.width / 4 * player.health / player.maxHealth;
            h_ = canvas2d.height / 20;
            x_ = canvas2d.width / 20;
            y_ = canvas2d.height - h_*2;
            //console.log('life:'+[x_,y_,w_,w2_,h_]);
            context.fillRect(x_,y_,w2_,h_);
            context.strokeRect(x_,y_,w_,h_);
            
            // potion gauge
            context.fillStyle='skyblue'; 
            w_ = canvas2d.width / 4;
            w2_ = canvas2d.width / 4 * player.shield / player.maxShield;
            h_ = canvas2d.height / 20;
            x_ = canvas2d.width / 20;
            y_ = canvas2d.height - h_*3;
            context.fillRect(x_,y_,w2_,h_);
            context.strokeRect(x_,y_,w_,h_);


            //weapons
            w_ = canvas2d.width / 5;
            w2_ = w_ / 5;
            h_ = canvas2d.height / 10;
            x_ = canvas2d.width / 4 * 3;
            y_ = canvas2d.height - h_*2;
            
            context.lineWidth = 10;
            for(var i=0;i<5;i++){
                context.strokeStyle = 'white';
                context.strokeRect(x_+w2_*i,y_,w2_,h_);
            }
            context.strokeStyle = 'red';
            context.strokeRect(x_+w2_*(player.weapon-1),y_,w2_,h_);

            context.font = mFontSize2+ 'px Bold Arial';
            context.fillStyle="black";
            context.fillText( 'AR', x_+w2_*0+10,y_+h_*0.7);
            context.fillText( 'SG', x_+w2_*1+10,y_+h_*0.7);
            context.fillText( 'SR', x_+w2_*2+10,y_+h_*0.7);
            context.fillText( 'B'+player.bandages, x_+w2_*3+10,y_+h_*0.7);
            context.fillText( 'P'+player.potions, x_+w2_*4+10,y_+h_*0.7);

            // give damage
            if(mDisplayDamage>0){
                x_ = W_/2;
                y_ = H_/2;
                var t_ = mDisplayDamage * 3;
                context.font = (mFontSize1*10)+'px Bold Arial'; //(mFontSize1*5)
                context.fillStyle="yellow";
                context.fillText( ' +'+player.giveDamage*1, x_+t_,y_-t_);        
            }


        }// your player

        // Player list
        if(1){
            var x_,y_,w_,w2_,h_;
            w_ = canvas2d.width / 8;
            h_ = canvas2d.height / 60;
            x_ = canvas2d.width / 50;
            y_ = 100 + h_*4*p_;

            context.lineWidth = 1;
            context.font = mFontSize1+'px Bold Arial';
            context.fillStyle="white";
            context.fillText(player.nickname, x_, y_-3);
            context.strokeStyle = 'black';

            context.fillStyle='skyblue';
            w2_ = w_ * player.shield / player.maxShield;
            context.fillRect(x_,y_,w2_,h_);
            context.strokeRect(x_,y_,w_,h_);
            context.fillStyle='green';
            if(player.inStorm==1){
                context.fillStyle='red';
            }
            y_ += h_; 
            w2_ = w_ * player.health / player.maxHealth;
            context.fillRect(x_,y_,w2_,h_);
            context.strokeRect(x_,y_,w_,h_);
        }

        p_ += 1;
    }); //players
    
    // Bullets
    // Object.values(bullets).forEach((bullet) => {
    //     let mesh = Meshes[bullet.id];
    //     if(!mesh){
    //         mesh = new THREE.Mesh(new THREE.BoxGeometry(bullet.height, bullet.height, bullet.width), bulletMaterial);
	// 	    mesh.castShadow = true;
    // 		Meshes[bullet.id] = mesh;
	// 	    // Meshes.push(mesh);
	// 	    scene.add(mesh);
    //     }
    //     mesh.used = true;
    //     var bl = bullet.width/2;
    //     var ba = bullet.angle;
    //     var ba2 = bullet.angle2;
    //     mesh.position.set(bullet.y + bl*Math.cos(-ba2)*Math.sin(ba)*0, bullet.z + bl*Math.sin(-ba2)*0, bullet.x + bl*Math.cos(-ba2)*Math.cos(ba)*0);
    //     mesh.rotation.y =  ba;
    //     mesh.rotation.x =  ba2;
    // });
    
    // Walls
    Object.values(walls).forEach((wall) => {
        
        let wallMesh = Meshes[wall.id];

        if(wallMesh){
            scene.remove(wallMesh);
            wallMesh.traverse((mesh2) => {
                if(mesh2.geometry){
                    mesh2.geometry.dispose();
                }
            });
            delete Meshes[wall.id];
        }
    
        wallMesh = new THREE.Group();

        //console.log('wall.isEditMode:'+wall.isEditMode);
        if(wall.isEditMode==1){
            
            for(var i=0;i<3; i++){
                for(var j=0;j<3; j++){
                    if(wall.gridSelected[i*3+j]==1){
                        mesh = new THREE.Mesh(new THREE.BoxGeometry(wall.gridSize[1], wall.gridSize[2], wall.gridSize[0]), editSelectedGridMaterial);
                    }
                    else{
                        mesh = new THREE.Mesh(new THREE.BoxGeometry(wall.gridSize[1], wall.gridSize[2], wall.gridSize[0]), editGridMaterial);
                    }
                    mesh.position.set(wall.gridOrigin[(i*3+j)*3+1] + wall.gridSize[1]/2, 
                                      wall.gridOrigin[(i*3+j)*3+2] + wall.gridSize[2]/2, 
                                      wall.gridOrigin[(i*3+j)*3+0] + wall.gridSize[0]/2);
                    wallMesh.add(mesh);
                }
            }

            var s_ = 20;
            mesh = new THREE.Mesh(new THREE.BoxGeometry(s_, s_, s_), botMaterial1);
            mesh.position.set(wall.y, wall.z, wall.x);
            wallMesh.add(mesh);

            Meshes[wall.id] = wallMesh;
    		scene.add(wallMesh);
            
        }
        else if(wall.isEditMode==2){
            
            
        }
        else if(wall.isEditMode==0)
        {
            // if(wall.health>50){
            //     mesh = new THREE.Mesh(new THREE.BoxGeometry(wall.Ly, wall.Lz, wall.Lx), wallMaterial);
            // }
            // else{
            //     mesh = new THREE.Mesh(new THREE.BoxGeometry(wall.Ly, wall.Lz, wall.Lx), wallMaterial_d);
            // }
    		// mesh.castShadow = true;
            // mesh.position.set(wall.y + wall.Ly/2, wall.z+wall.Lz/2, wall.x + wall.Lx/2);
    	
            // wallMesh.add(mesh);

            var s_ = 20;
            mesh = new THREE.Mesh(new THREE.BoxGeometry(s_, s_, s_), botMaterial1);
            mesh.position.set(wall.y, wall.z, wall.x);
            wallMesh.add(mesh);

            var dt = mGlobalTime - wall.hitTime;
            var Lt = 50;
            if( dt < Lt){
                console.log('Hit:'+[mGlobalTime, wall.hitTime]);
                console.log('   :'+wall.hitPosition);
                mesh = new THREE.Mesh(new THREE.SphereGeometry(s_*0.5*dt/Lt, 10, 10), playerMaterialf);
                mesh.position.set(wall.hitPosition[1], wall.hitPosition[2], wall.hitPosition[0]);
                wallMesh.add(mesh);    
            }

            Meshes[wall.id] = wallMesh;
    		scene.add(wallMesh);
        }

        wallMesh.used = true;

    });

    // Floors
    Object.values(floors).forEach((floor) => {
        
        let floorMesh = Meshes[floor.id];

        if(floorMesh){
            scene.remove(floorMesh);
            floorMesh.traverse((mesh2) => {
                if(mesh2.geometry){
                    mesh2.geometry.dispose();
                }
            });
            delete Meshes[floor.id];
        }
    
        floorMesh = new THREE.Group();

        //console.log('floor.isEditMode:'+floor.isEditMode);
        if(floor.isEditMode==1){
            
            // for(var i=0;i<2; i++){
            //     for(var j=0;j<2; j++){
            //         if(floor.gridSelected[i*2+j]==1){
            //             mesh = new THREE.Mesh(new THREE.BoxGeometry(floor.gridSize[1], floor.gridSize[2], floor.gridSize[0]), editSelectedGridMaterial);
            //         }
            //         else{
            //             mesh = new THREE.Mesh(new THREE.BoxGeometry(floor.gridSize[1], floor.gridSize[2], floor.gridSize[0]), editGridMaterial);
            //         }
            //         mesh.position.set(floor.gridOrigin[(i*2+j)*3+1] + floor.gridSize[1]/2, 
            //                           floor.gridOrigin[(i*2+j)*3+2] + floor.gridSize[2]/2 + floor.gridSelected[i*2+j]*10, 
            //                           floor.gridOrigin[(i*2+j)*3+0] + floor.gridSize[0]/2 );
            //         floorMesh.add(mesh);

            //     }
            // }

            let geometry = new THREE.Geometry();
            let geometry_s = new THREE.Geometry();
            let P =  floor.gridP;
            //let F =  floor.gridF;
            //console.log('cone.P:'+P);

            var dz = 10;    
            mSetGridGeometry(floor, P, geometry, geometry_s, dz);

            var Triangle, Triangle_s;
            Triangle = new THREE.Mesh(geometry, editGridMaterial);
            Triangle_s = new THREE.Mesh(geometry_s, editSelectedGridMaterial);
            floorMesh.add(Triangle);
            floorMesh.add(Triangle_s);


            var s_ = 20;
            mesh = new THREE.Mesh(new THREE.BoxGeometry(s_, s_, s_), botMaterial1);
            mesh.position.set(floor.y, floor.z, floor.x);
            floorMesh.add(mesh);

            Meshes[floor.id] = floorMesh;
    		scene.add(floorMesh);
            
        }
        else if(floor.isEditMode==2){
            
            
        }
        else if(floor.isEditMode==0){
           
            // let mat = wallMaterial;
            // if(floor.health<=50){
            //     mat = wallMaterial_d;
            // }
            // mesh = new THREE.Mesh(new THREE.BoxGeometry(floor.Ly, floor.Lz, floor.Lx), mat);
    		// mesh.castShadow = true;
            // mesh.position.set(floor.y + floor.Ly/2, floor.z, floor.x + floor.Lx/2); //+floor.Lz/2
    	
            // floorMesh.add(mesh);

            var s_ = 20;
            mesh = new THREE.Mesh(new THREE.BoxGeometry(s_, s_, s_), botMaterial1);
            mesh.position.set(floor.y, floor.z, floor.x);
            floorMesh.add(mesh);

            var dt = mGlobalTime - floor.hitTime;
            var Lt = 50;
            if( dt < Lt){
                mesh = new THREE.Mesh(new THREE.SphereGeometry(s_*0.5*dt/Lt, 10, 10), playerMaterialf);
                mesh.position.set(floor.hitPosition[1], floor.hitPosition[2], floor.hitPosition[0]);
                floorMesh.add(mesh);    
            }

            Meshes[floor.id] = floorMesh;
    		scene.add(floorMesh);
        }

        floorMesh.used = true;

    });


    // Slopes
    Object.values(slopes).forEach((slope) => {
        
        let slopeMesh = Meshes[slope.id];

        if(slopeMesh){
            scene.remove(slopeMesh);
            slopeMesh.traverse((mesh2) => {
                if(mesh2.geometry){
                    mesh2.geometry.dispose();
                }
            });
            delete Meshes[slope.id];
        }
    
        slopeMesh = new THREE.Group();

        //console.log('slope.isEditMode:'+slope.isEditMode);
        if(slope.isEditMode==1){

            mesh = new THREE.Mesh(new THREE.BoxGeometry(slope.Ly, slope.Lz, slope.Lx), wallMaterial_t);
            mesh.castShadow = true;
            mesh.position.set(slope.y + mFieldGridSize/2, slope.z - slope.Lz/2, slope.x + mFieldGridSize/2);
            if((slope.angle == 3.1415/2)||(slope.angle == 3.1415/2*3) ){
                mesh.rotation.z = -slope.angle2;
            }    
            else{
                mesh.rotation.x = slope.angle2;
            }   
            slopeMesh.add(mesh); 

            var s_ = 20;
            mesh = new THREE.Mesh(new THREE.BoxGeometry(s_, s_, s_), botMaterial1);
            mesh.position.set(slope.y, slope.z, slope.x);
            
            slopeMesh.add(mesh);

            Meshes[slope.id] = slopeMesh;
            scene.add(slopeMesh);


            for(var i=0;i<2; i++){
                for(var j=0;j<2; j++){
                    if(slope.pGridSelected[i*2+j]==1){
                        mesh = new THREE.Mesh(new THREE.BoxGeometry(slope.pGridSize[1], slope.pGridSize[2], slope.pGridSize[0]), editGridMaterial);
                    }
                    else{
                        mesh = new THREE.Mesh(new THREE.BoxGeometry(slope.pGridSize[1], slope.pGridSize[2], slope.pGridSize[0]), editSelectedGridMaterial);
                    }
                    mesh.position.set(slope.pGridOrigin[(i*2+j)*3+1] + slope.pGridSize[1]/2, 
                                      slope.pGridOrigin[(i*2+j)*3+2] + slope.pGridSize[2]/2 , 
                                      slope.pGridOrigin[(i*2+j)*3+0] + slope.pGridSize[0]/2 );
                    slopeMesh.add(mesh);

                    var ii = i*2+j;
                    if(slope.dGridSelected[ii]==1){
                        mesh = new THREE.Mesh(new THREE.BoxGeometry(slope.dGridSize[ii*3+1], slope.dGridSize[ii*3+2], slope.dGridSize[ii*3+0]), editGridMaterial);
                    }
                    else{
                        mesh = new THREE.Mesh(new THREE.BoxGeometry(slope.dGridSize[ii*3+1], slope.dGridSize[ii*3+2], slope.dGridSize[ii*3+0]), editSelectedGridMaterial);
                    }
                    mesh.position.set(slope.dGridOrigin[ii*3+1] + slope.dGridSize[ii*3+1]/2, 
                                      slope.dGridOrigin[ii*3+2] + slope.dGridSize[ii*3+2]/2 , 
                                      slope.dGridOrigin[ii*3+0] + slope.dGridSize[ii*3+0]/2 );
                    slopeMesh.add(mesh);
                }
            }

            Meshes[slope.id] = slopeMesh;
    		scene.add(slopeMesh);
        }
        else if(slope.isEditMode==2){
            
        }
        else if(slope.isEditMode==0){
 
            var x = slope.pvec[0];
            var y = slope.pvec[1];
            var z = slope.pvec[2];
            //console.log('xyz:'+[x,y,z]);

            var Lx = slope.pvec[3];
            var Ly = slope.pvec[4];
            var Lz = Math.max( slope.pvec[5], slope.pvec[8] );

            if(Lx==0){
                Lx = slope.pvec[6];
            }
            if(Ly==0){
                Ly = slope.pvec[7];
            }
            //console.log('L:'+[Lx,Ly,Lz]);

            if(Lx<0){
                Lx = Math.abs(Lx);
                x -= Lx;
            }
            if(Ly<0){
                Ly = Math.abs(Ly);
                y -= Ly;
            }

            // let mat = wallMaterial;
            // if(slope.health<=50){
            //     mat = wallMaterial_d;
            // }
            // mesh = new THREE.Mesh(new THREE.BoxGeometry(slope.Ly, slope.Lz, slope.Lx), mat); //wallMaterial);
            // mesh.position.set(y + Ly/2, z + Lz/2 + slope.Lz/2, x + Lx/2);
            
            // if((slope.angle == 3.1415/2)||(slope.angle == 3.1415/2*3) ){
            //     mesh.rotation.z = -slope.angle2;
            // }    
            // else{
            //     mesh.rotation.x = slope.angle2;
            // }   
            // slopeMesh.add(mesh); 

            var s_ = 20;
            mesh = new THREE.Mesh(new THREE.BoxGeometry(s_, s_, s_), botMaterial1);
            mesh.position.set(y, z + slope.Lz, x);
            
            slopeMesh.add(mesh);

            var dt = mGlobalTime - slope.hitTime;
            var Lt = 50;
            if( dt < Lt){
                mesh = new THREE.Mesh(new THREE.SphereGeometry(s_*0.5*dt/Lt, 10, 10), playerMaterialf);
                mesh.position.set(slope.hitPosition[1], slope.hitPosition[2], slope.hitPosition[0]);
                slopeMesh.add(mesh);    
            }

            Meshes[slope.id] = slopeMesh;
            scene.add(slopeMesh);

        }
        
        slopeMesh.used = true;
    });


    // Triangles
    Object.values(triangles).forEach((triangle) => {

        let triangleMesh = Meshes[triangle.id];

        if(triangleMesh){
            scene.remove(triangleMesh);
            triangleMesh.traverse((mesh2) => {
                if(mesh2.geometry){
                    mesh2.geometry.dispose();
                }
            });
            delete Meshes[triangle.id];
        }

        triangleMesh = new THREE.Group();
        let geometry = new THREE.Geometry();
        geometry.castShadow = true;

        let P =  triangle.P;
        let F =  triangle.F;
        //console.log('cone.P:'+P);

        //y,z,x
        for(var i=0;i<3;i++){ 
            geometry.vertices[i] = new THREE.Vector3(P[i][1], P[i][2], P[i][0]);
        }
        for(var i=0;i<1;i++){ 
            geometry.faces[i*2+0] = new THREE.Face3(F[i][0],F[i][1],F[i][2]);//counter clock wise
            geometry.faces[i*2+1] = new THREE.Face3(F[i][0],F[i][2],F[i][1]);//back side       
        }     
        geometry.computeFaceNormals();

        var Triangle;
        if(triangle.isEditMode==0){
            let mat = wallMaterial;
            if(triangle.health<=50){
                mat = wallMaterial_d;
            }
            Triangle = new THREE.Mesh(geometry, mat);//wallMaterial);
        }
        else if(triangle.isEditMode==1){
            Triangle = new THREE.Mesh(geometry,wallMaterial_t);
        }
        Triangle.castShadow = true;
        triangleMesh.add(Triangle);
        triangleMesh.castShadow = true;

        var s_ = 20;
        var dt = mGlobalTime - triangle.hitTime;
        var Lt = 50;
        if( dt < Lt){
            mesh = new THREE.Mesh(new THREE.SphereGeometry(s_*0.5*dt/Lt, 10, 10), playerMaterialf);
            mesh.position.set(triangle.hitPosition[1], triangle.hitPosition[2], triangle.hitPosition[0]);
            triangleMesh.add(mesh);    
        }

        Meshes[triangle.id] = triangleMesh;
        scene.add(triangleMesh);

        triangleMesh.used = true;
    });


    // Cones
    Object.values(cones).forEach((cone) => {

        let coneMesh = Meshes[cone.id];

        if(coneMesh){
            scene.remove(coneMesh);
            coneMesh.traverse((mesh2) => {
                if(mesh2.geometry){
                    mesh2.geometry.dispose();
                }
            });
            delete Meshes[cone.id];
        }

        coneMesh = new THREE.Group();
       
        //console.log('cone:'+cone.id);
        //console.log('cone.isEditMode:'+cone.isEditMode);

        if(cone.isEditMode==1){
            
            let geometry = new THREE.Geometry();
            let geometry_s = new THREE.Geometry();
            let P =  cone.gridP;
            //let F =  floor.gridF;
            //console.log('cone.P:'+P);

            var dz = 10;    
            mSetGridGeometry(cone, P, geometry, geometry_s, dz);

            var Triangle, Triangle_s;
            Triangle = new THREE.Mesh(geometry, editGridMaterial);
            Triangle_s = new THREE.Mesh(geometry_s, editGridMaterial);
            coneMesh.add(Triangle);
            coneMesh.add(Triangle_s);


            var s_ = 20;
            mesh = new THREE.Mesh(new THREE.BoxGeometry(s_, s_, s_), botMaterial1);
            mesh.position.set(cone.y, cone.z, cone.x);
            coneMesh.add(mesh);

            Meshes[cone.id] = coneMesh;
    		scene.add(coneMesh);       
        }

        coneMesh.used = true;
    });

    
    // Bandages
    Object.values(bandages).forEach((bandage) => {
        let mesh = Meshes[bandage.id];
        if(!mesh){
            mesh = new THREE.Mesh(new THREE.CylinderGeometry(bandage.width,bandage.width,bandage.tall,10,10,false), bandageMaterial); 
            mesh.position.set(bandage.y + bandage.width/2, bandage.z+bandage.tall/2, bandage.x + bandage.height/2);
    		Meshes.push(mesh);
    		Meshes[bandage.id] = mesh;
    		scene.add(mesh);            
        }
        mesh.used = true;
        
    });

    // Potions
    Object.values(potions).forEach((potion) => {
        let mesh = Meshes[potion.id];
        if(!mesh){
    		mesh = new THREE.Mesh(new THREE.CylinderGeometry(potion.width,potion.width,potion.tall,10,10,false), potionMaterial); 
            mesh.position.set(potion.y + potion.width/2, potion.z+potion.tall/2, potion.x + potion.height/2);
    		Meshes.push(mesh);
    		Meshes[potion.id] = mesh;
    		scene.add(mesh);
        }
        mesh.used = true;
        
    });

    //Strom
    // let meshStorm = Meshes[mStorm.id];
    // if(!meshStorm){
    //     meshStorm = new THREE.Mesh(new THREE.CylinderGeometry(mStorm.width, mStorm.width, FIELD_WIDTH, 50,50,true), stormMaterial); 
    //     Meshes.push(meshStorm);
    //     Meshes[mStorm.id] = meshStorm;
    //     scene.add(meshStorm);    
    // }
    // meshStorm.used = true;
    // meshStorm.position.set(mStorm.x, -10, mStorm.y);
    // var storm_scale = mStorm.width / meshStorm.geometry.parameters.radiusTop;
    // //console.log('storm:'+mStorm.width+', '+meshStorm.geometry.parameters.radiusTop);
    // //console.log('storm:'+storm_scale);
    // meshStorm.scale.x = storm_scale;
    // meshStorm.scale.z = storm_scale;

    
    // Clear unused Meshes
    Object.keys(Meshes).forEach((key) => {
        const mesh = Meshes[key];
        if(!mesh.used){
            //console.log('removing mesh', key);
            scene.remove(mesh);
            mesh.traverse((mesh2) => {
                if(mesh2.geometry){
                    mesh2.geometry.dispose();
                }
            });
            delete Meshes[key];
        }
    });

    //renderer.render( scene, camera );

});



function mSetGridGeometry(floor, P, geometry, geometry_s, dz)
{
    var n = 0;
    var n_s = 0;            
    for(var i=0;i<4;i++){
        if(floor.gridSelected[i]==0){
            //y,z,x
            geometry.vertices[n*4+0] = new THREE.Vector3(P[i*4+0][1], P[i*4+0][2]+dz, P[i*4+0][0]);
            geometry.vertices[n*4+1] = new THREE.Vector3(P[i*4+1][1], P[i*4+1][2]+dz, P[i*4+1][0]);
            geometry.vertices[n*4+2] = new THREE.Vector3(P[i*4+2][1], P[i*4+2][2]+dz, P[i*4+2][0]);
            geometry.vertices[n*4+3] = new THREE.Vector3(P[i*4+3][1], P[i*4+3][2]+dz, P[i*4+3][0]);

            geometry.faces[n*4+0] = new THREE.Face3(n*4+0,n*4+1,n*4+2); 
            geometry.faces[n*4+1] = new THREE.Face3(n*4+0,n*4+2,n*4+1); 
            geometry.faces[n*4+2] = new THREE.Face3(n*4+0,n*4+2,n*4+3); 
            geometry.faces[n*4+3] = new THREE.Face3(n*4+0,n*4+3,n*4+2); 
            n += 1;
        }
        else if(floor.gridSelected[i]==1){
            geometry_s.vertices[n_s*4+0] = new THREE.Vector3(P[i*4+0][1], P[i*4+0][2]+dz*2, P[i*4+0][0]);
            geometry_s.vertices[n_s*4+1] = new THREE.Vector3(P[i*4+1][1], P[i*4+1][2]+dz*2, P[i*4+1][0]);
            geometry_s.vertices[n_s*4+2] = new THREE.Vector3(P[i*4+2][1], P[i*4+2][2]+dz*2, P[i*4+2][0]);
            geometry_s.vertices[n_s*4+3] = new THREE.Vector3(P[i*4+3][1], P[i*4+3][2]+dz*2, P[i*4+3][0]);

            geometry_s.faces[n_s*4+0] = new THREE.Face3(n_s*4+0,n_s*4+1,n_s*4+2); 
            geometry_s.faces[n_s*4+1] = new THREE.Face3(n_s*4+0,n_s*4+2,n_s*4+1); 
            geometry_s.faces[n_s*4+2] = new THREE.Face3(n_s*4+0,n_s*4+2,n_s*4+3); 
            geometry_s.faces[n_s*4+3] = new THREE.Face3(n_s*4+0,n_s*4+3,n_s*4+2); 
            n_s += 1;
        }
    }
    //console.log('floor grid:'+[n, n_s]);
    //console.log('geometry:'+geometry.vertices);
    // for(var i=0;i<n;i++){
    //     console.log('geometry:'+[geometry.vertices[i*4+0].x, geometry.vertices[i*4+0].y, geometry.vertices[i*4+0].z]);
    //     console.log('geometry:'+[geometry.vertices[i*4+1].x, geometry.vertices[i*4+1].y, geometry.vertices[i*4+1].z]);
    //     console.log('geometry:'+[geometry.vertices[i*4+2].x, geometry.vertices[i*4+2].y, geometry.vertices[i*4+2].z]);
    //     console.log('geometry:'+[geometry.vertices[i*4+3].x, geometry.vertices[i*4+3].y, geometry.vertices[i*4+3].z]);
    // }

    geometry.computeFaceNormals();
    geometry_s.computeFaceNormals();

    return;
}//



// Load 
function mDrawLoad(v_){

    var W_ = canvasLoad.width;
    var H_ = canvasLoad.height;
    var x_,y_,w_,w2_,h_;

    contextLoad.clearRect(0, 0, W_, H_);
        
    var s_ = (mFontSize1*5);
    x_ = W_ / 4;
    y_ = H_ / 10;
    w_ = W_/2;
    h_ = s_ * 1.3;

    x_ = W_ / 2 - s_*2;
    y_ += s_;
    contextLoad.font = s_+'px Bold Arial';
    contextLoad.fillStyle="white";
    contextLoad.fillText( 'Loading'+v_*10+'%', x_, y_);

}


// Victory
function mDrawVictroy(){

    var W_ = canvasVic.width;
    var H_ = canvasVic.height;
    var x_,y_,w_,w2_,h_;

    contextVic.clearRect(0, 0, W_, H_);
    
    var s_ = (mFontSize1*10);
    x_ = W_ / 4;
    y_ = H_ / 10;
    w_ = W_/2;
    h_ = s_ * 1.3;
    contextVic.fillStyle="blue";
    contextVic.fillRect(x_, y_, w_, h_);

    x_ = W_ / 2 - s_*2;
    y_ += s_;
    contextVic.font = s_+'px Bold Arial';
    contextVic.fillStyle="white";
    contextVic.fillText( '#1 優勝!!', x_, y_);
    s_ = (mFontSize1*2);
    y_ +=  s_;
    contextVic.font = s_+'px Bold Arial';
    contextVic.fillStyle="white";
    x_ = W_ / 2 - s_*3;
    contextVic.fillText( '夕飯はお寿司だ', x_, y_);

}

function mDrawResults(n_){

    var W_ = canvasVic.width;
    var H_ = canvasVic.height;
    var x_,y_,w_,w2_,h_;

    contextVic.clearRect(0, 0, W_, H_);
    
    var s_ = (mFontSize1*10);
    x_ = W_ / 2 - s_;
    y_ = H_ / 5;
    contextVic.font = s_+'px Bold Arial';
    contextVic.fillStyle="black";
    contextVic.fillText( '#'+n_, x_,y_);
    contextVic.font = '40px Bold Arial';

}


socket.on('id', id_ => {
    mID = id_;
    console.log('mID:'+mID);
});

socket.on('shoot', function(a_) {
    var id_ = a_[0];
    var wp_ = a_[1];
    var vol_ = 0.3;

    if(id_==mID){
        vol_=1.0;
        if(wp_==1){
            mSoundEffect(ShotSound1,vol_);
        }
        else if(wp_==2){
            mSoundEffect(ShotSound2,vol_);
        }
        else if(wp_==3){
            mSoundEffect(ShotSound3,vol_);
        }    
    }
    else{
        if(wp_==1){
            mSoundEffect(ShotSound1.cloneNode(),vol_);
        }
        else if(wp_==2){
            mSoundEffect(ShotSound2.cloneNode(),vol_);
        }
        else if(wp_==3){
            mSoundEffect(ShotSound3.cloneNode(),vol_);
        }    
    }


});

socket.on('empty', () => {
    mSoundEffect(EmptySound,1.0);
});

// socket.on('shootFromOthers', vol_ => {
//     mSoundEffect(ShotSoundOthers1,vol_);
// });
socket.on('shootFromOthers', function(a_) 
{
    //console.log('shootFromOthers:'+a_[0]);
    if(a_[0]==1){
        mSoundEffect(ShotSound1,a_[1]);
    }
    else if(a_[0]==2){
        mSoundEffect(ShotSound2,a_[1]);
    }
    else if(a_[0]==3){
        mSoundEffect(ShotSound3,a_[1]);
    }
    
});

socket.on('shootFromBot', vol_ => {
    mSoundEffect(ShotSoundOthers1,vol_);
});

socket.on('displayGiveDamage', v_ => {
    mDisplayDamage = v_;
});

socket.on('givedamage', vol_ => {
    mSoundEffect(GiveDamageSound,vol_);
});
socket.on('recievedamage', vol_ => {
    mSoundEffect(RecieveDamageSound,vol_);
});
socket.on('walldamage', vol_ => {
    mSoundEffect(WallDamageSound,vol_);
});

socket.on('deadothers', () => {
    mSoundEffect(RemoveSound,1.0);
});


socket.on('didBuild', () => {
    mSoundEffect(WallSetSound,1.0); 
});

socket.on('startEdit', () => {
    mSoundEffect(EditSound,1.0);
    mMode = 3; 
});

socket.on('didEdit', () => {
    mSoundEffect(EditSound,1.0);
    mMode = 2; 
});

socket.on('getItem', () => {
    mSoundEffect(GetItemSound,1.0);
});

socket.on('usedBandage', () => {
    mSoundEffect(UsedBandageSound,1.0);
});

socket.on('cannotUseBandage', () => {
    mSoundEffect(CannotUseBandageSound,1.0);
});

socket.on('usedPotion', () => {
    mSoundEffect(UsedBandageSound,1.0);
});

socket.on('cannotUsePotion', () => {
    mSoundEffect(CannotUseBandageSound,1.0);
});

socket.on('victory', () => {
    DocumentExitPointerLock(canvas2d);
    mDrawVictroy();
    //$("#help-screen").show();
    $("#canvas-vic").show();
    //$("#start-screen").show();
    
    //mSoundEffect(ChurchSound,1.0);
    ChurchSound.play();
});

socket.on('dead', n_ => {
    if(n_>1){
        mDrawResults(n_);
        $("#canvas-vic").show();
    }
    $("#help-screen").show();
    $("#start-screen").show();  
});
